package ch.zhaw.ads;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class TreeTraversal<T extends Comparable<T>> implements Traversal<T> {
    private final TreeNode<T> root;

    public TreeTraversal(TreeNode<T> root) {
        this.root = root;
    }

    @Override
    public void interval(T min, T max, Visitor<T> vistor) {

    }

    public void inorder(Visitor<T> vis) {
        inorderRec(vis, root);
    }

    private void inorderRec(Visitor<T> vis, TreeNode<T> root){
        if(root.left != null){
            inorderRec(vis, root.left);
        }
        vis.visit(root.getValue());
        if(root.right != null){
            inorderRec(vis, root.right);
        }
    }

    public void preorder(Visitor<T> vis) {
        Stack<TreeNode<T>> stack = new Stack();
        TreeNode<T> node = root;
        stack.push(node);
        while(!stack.isEmpty()) {
            node = stack.pop();
            vis.visit(node.getValue());
            if(node.right != null){
                stack.push(node.right);
            }
            if(node.left != null) {
                stack.push(node.left);
            }
        }
    }

    public void postorder(Visitor<T> vis) {
        postorderRec(vis, root);
    }

    public void postorderRec(Visitor<T> vis, TreeNode<T> root){
        inorderRec(vis, root.left);
        inorderRec(vis, root.right);
        vis.visit(root.getValue());
    }

    public void levelorder(Visitor<T> vis){
        List<TreeNode<T>> nodes = new ArrayList<>();
        nodes.add(root);
    }

    public void levelorderRec(Visitor<T> vis, List<TreeNode<T>> nodes){
        List<TreeNode<T>> newNodes = new ArrayList<>();
        for (TreeNode<T> node : nodes){
            if(node.right != null){
                newNodes.add(node.right);
            }
            if(node.left != null) {
                newNodes.add(node.left);
            }
            vis.visit(node.getValue());
        }
        if(newNodes.size() > 0){
            levelorderRec(vis, newNodes);
        }

    }
}
